#!/usr/bin/env node
import he from"open";import ue from"update-notifier";import we from"jsonfile";import{Listr as xe}from"listr2";import{stringify as ye}from"query-string";import{clipboard as be}from"clipboard-sys";import W from"meow";import Y from"inquirer";import J from"clipboardy";import K from"lodash";import Z from"get-stdin";var l={t:{"3024 Night":"3024-night","A11y Dark":"a11y-dark","Base 16 (Dark)":"base16-dark","Base 16 (Light)":"base16-light",Blackboard:"blackboard",Cobalt:"cobalt",Dracula:"dracula-pro",Duotone:"duotone-dark",Hopscotch:"hopscotch",Lucario:"lucario",Material:"material",Monokai:"monokai","Night Owl":"night-owl",Nord:"nord","Oceanic Next":"oceanic-next","One Dark":"one-dark","One Light":"one-light",Panda:"panda-syntax",Paraiso:"paraiso-dark",Seti:"seti","Shades of Purple":"shades-of-purple","Solarized (Dark)":"solarized dark","Solarized (Light)":"solarized light","SynthWave 84":"synthwave-84",Twilight:"twilight",VSCode:"vscode",Verminal:"verminal",Yeti:"yeti",Zenburn:"zenburn"},wt:{None:"none",Sharp:"sharp","Black & White":"bw"},fm:{"Anonymous Pro":"Anonymous Pro","Cascadia Code":"Cascadia Code","Droid Sans Mono":"Droid Sans Mono","Fantasque Sans Mono":"Fantasque Sans Mono","Fira Code":"Fira Code",Hack:"Hack","IBM Plex Mono":"IBM Plex Mono",Inconsolata:"Inconsolata","JetBrains Mono":"JetBrains Mono",Monoid:"Monoid","Source Code Pro":"Source Code Pro","Space Mono":"Space Mono","Ubuntu Mono":"Ubuntu Mono"},es:{"2x":"2x","1x":"1x","4x":"4x"}};import{readFile as U}from"node:fs/promises";var x=async(t,e=!0)=>await U(t,{encoding:e?"utf8":null});import{homedir as G}from"os";var V=".carbon-now.json",z=G(),b=`${z}/${V}`,n="latest-preset";var E={start:{type:"number",alias:"s",default:1},end:{type:"number",alias:"e",default:1e3},openInBrowser:{type:"boolean",default:!1},saveTo:{type:"string",default:process.cwd()},saveAs:{type:"string"},interactive:{type:"boolean",alias:"i",default:!1},preset:{type:"string",alias:"p",default:n},toClipboard:{type:"boolean",default:!1},config:{type:"string"},fromClipboard:{type:"boolean",default:!1},disableHeadless:{type:"boolean",default:!1},engine:{type:"string",default:"chromium"}};var A=[{type:"list",name:"t",message:"Syntax theme:",default:"3024 Night",choices:Object.keys(l.t)},{type:"list",name:"wt",message:"Window theme:",default:"none",choices:Object.keys(l.wt)},{type:"list",name:"fm",message:"Font family:",default:"Hack",choices:Object.keys(l.fm)},{type:"input",name:"fs",message:"Font size:",default:"18px"},{type:"input",name:"bg",message:"Background color:",default:"#ADB7C1"},{type:"confirm",name:"wc",message:"Include window controls?",default:!0},{type:"confirm",name:"ln",message:"Include line numbers?",default:!1},{type:"input",name:"fl",message:"Starting line number?",default:"1",when:t=>t.ln},{type:"confirm",name:"wa",message:"Auto adjust width?",default:!0},{type:"input",name:"lh",message:"Line height:",default:"133%"},{type:"input",name:"pv",message:"Vertical padding:",default:"0px"},{type:"input",name:"ph",message:"Horizontal padding:",default:"0px"},{type:"confirm",name:"ds",message:"Include drop shadow?",default:!1},{type:"input",name:"dsyoff",message:"Drop shadow y-offset:",default:"20px",when:t=>t.ds},{type:"input",name:"dsblur",message:"Drop shadow blur:",default:"68px",when:t=>t.ds},{type:"confirm",name:"highlight",message:"Highlight certain lines?",default:!1},{type:"input",name:"sl",message:"Comma-separated list of lines to highlight, e.g., 4,5,6,7",default:"*",when:t=>t.highlight},{type:"confirm",name:"si",message:"Make squared image?",default:!1},{type:"confirm",name:"wm",message:"Add Carbon watermark?",default:!1},{type:"list",name:"es",message:"Export size:",default:"2x",choices:Object.keys(l.es)},{type:"list",name:"type",message:"Export as\u2026",default:"png",choices:["png","svg"]},{type:"confirm",name:"save",message:"Save these settings as a preset?",default:!1},{type:"input",name:"preset",message:"Name of the preset? Use kebab-case.",default:n,when:t=>t.save}];import k from"chalk";var I=`
  ${k.bold("Usage")}
    $ carbon-now <file>
    $ pbpaste | carbon-now
    $ carbon-now --from-clipboard

  ${k.bold("Options")}
    -s, --start          Starting line of input
    -e, --end            Ending line of input
    -i, --interactive    Interactive mode
    -p, --preset         Apply an existing preset
    --save-to            Image save location, default: cwd
    --save-as            Image name, default: original-hash.{png|svg}
    --from-clipboard     Read input from clipboard instead of file
    --to-clipboard       Copy image to clipboard
    --open-in-browser    Open in browser instead of saving
    --config             Use a different, local config (read-only)
    --disable-headless   Run Playwright in headful mode
    --engine             Use different rendering engine, default: \`chromium\`
                         Options: \`chromium\`, \`firefox\`, \`webkit\`

  ${k.bold("Examples")}
    See: https://github.com/mixn/carbon-now-cli#examples
`;import O from"chalk";var T=`
  ${O.red("No file or stdin given.")}

  ${O.bold("Usage")}
    $ carbon-now <file>
    $ pbpaste | carbon-now
    $ carbon-now --from-clipboard`;var d=class{file;flags;input;answers;static async create(){let e=new this;return await e.init(),e}async init(){[this.file,this.flags]=await this.initCLI(),this.input=await this.readInput(),this.answers=await this.initInteractiveMode()}async initCLI(){let e=W(I,{flags:E});return[e.input[0],e.flags]}async readInput(){let e;if(this.file)return await x(this.file);if(this.flags.fromClipboard)return J.readSync();if(e=await Z())return e;console.error(T),process.exit(1)}async initInteractiveMode(){return this.flags.interactive?this.mapAnswersToCarbonValues(await Y.prompt(A)):{}}mapAnswersToCarbonValues(e){return K.mapValues(e,(a,i)=>{var o;return((o=l[i])==null?void 0:o[a])??a})}get getFlags(){return this.flags}get getAnswers(){return this.answers}get getFile(){return this.file}get getInput(){return this.input}};import P from"jsonfile";import X from"file-exists";import ee from"lodash";import{EOL as te}from"os";import Q from"chalk";var M=t=>`
  ${Q.yellow(`Warning: Preset \`${t}\` doesn\u2019t exist. Using default settings\u2026`)}`;var f=class{configPath;ignoredSettings=["save","preset","l","highlight"];constructor(e=b){this.configPath=e}async writeConfig(e={},a={}){await P.writeFileSync(this.configPath,e,a)}async readConfig(){let e=this.configPath;return await X(e)?await P.readFileSync(e):e===b?(await this.writeConfig(),await this.readConfig()):{}}warn(e){console.warn(M(e))}async getPreset(e){let a=await this.readConfig();return e in a?a[e]:(this.warn(e),{})}async savePreset(e=n,a={}){let i=ee.omit(a,this.ignoredSettings),m={...await this.readConfig(),...e!==n&&{[e]:i},[n]:i};await this.writeConfig(m,{spaces:2,EOL:te})}};import ae from"file-extension";import{EOL as $}from"os";import{rename as se}from"node:fs/promises";var F=new Map([["C","text/x-c++src"],["c","text/x-csrc"],["c++","text/x-c++src"],["cbl","cobol"],["cc","text/x-c++src"],["cdxml","powershell"],["changes","smalltalk"],["cl","commonlisp"],["class","text/x-java"],["clj","clojure"],["cljc","clojure"],["cljs","clojure"],["cob","cobol"],["coffee","coffeescript"],["conf","nginx"],["cpp","text/x-c++src"],["cpy","cobol"],["cr","crystal"],["cs","smalltalk"],["css","css"],["csv","sql"],["cxx","text/x-c++src"],["d","d"],["dart","dart"],["db","sql"],["diff","text/x-diff"],["dockerfile","dockerfile"],["Dockerfile","dockerfile"],["edn","clojure"],["elm","elm"],["erl","erlang"],["ex","elixir"],["exs","elixir"],["f","fortran"],["f90","fortran"],["feature","gherkin"],["for","fortran"],["fs","mllike"],["fsi","mllike"],["fsscript","mllike"],["fsx","mllike"],["go","text/x-go"],["gql","graphql"],["graphql","graphql"],["groovy","groovy"],["h","text/x-csrc"],["h++","text/x-c++src"],["handlebars","handlebars"],["hbs","handlebars"],["hh","text/x-c++src"],["hpp","text/x-c++src"],["hrl","erlang"],["hs","haskell"],["htaccess","text/apache"],["html","htmlmixed"],["hx","haxe"],["hxml","haxe"],["hxx","text/x-c++src"],["ijl","julia"],["ijs","julia"],["inc","pascal"],["jar","text/x-java"],["java","text/x-java"],["jl","julia"],["jlt","julia"],["js","javascript"],["json","application/json"],["jsx","jsx"],["kt","text/x-kotlin"],["kts","text/x-kotlin"],["lhs","haskell"],["lisp","commonlisp"],["litcoffee","coffeescript"],["lp","lua"],["lsp","commonlisp"],["lua","lua"],["m","text/x-octave"],["md","markdown"],["mj2","julia"],["mj3","julia"],["mjl","julia"],["mjltest","julia"],["ml","mllike"],["mli","mllike"],["mm","text/x-objectivec"],["mysql","sql"],["nb","mathematica"],["nim","nim"],["nims","nim"],["nix","nix"],["nse","lua"],["nt","application/n-triples"],["oct","text/x-octave"],["octave","text/x-octave"],["p8","lua"],["pas","pascal"],["patch","text/x-diff"],["pd_lua","lua"],["php-s","text/x-php"],["php","text/x-php"],["php3","text/x-php"],["php4","text/x-php"],["php5","text/x-php"],["php7","text/x-php"],["phps","text/x-php"],["phtml","text/x-php"],["pl","perl"],["pm","perl"],["pp","pascal"],["pr","smalltalk"],["proto","protobuf"],["ps1","powershell"],["ps1xml","powershell"],["psc1","powershell"],["psd1","powershell"],["psm1","powershell"],["pssc","powershell"],["py","python"],["pyc","python"],["pyd","python"],["pyo","python"],["pyw","python"],["pyz","python"],["r","r"],["R","r"],["rb","ruby"],["rbxl","lua"],["rbxs","lua"],["rda","r"],["RData","r"],["rds","r"],["rq","application/sparql-query"],["rs","rust"],["rslib","rust"],["sass","sass"],["sc","text/x-scala"],["scala","text/x-scala"],["scode","smalltalk"],["scss","sass"],["sh","application/x-sh"],["sm","smalltalk"],["smalltalk","smalltalk"],["sol","solidity"],["sources","smalltalk"],["sql","sql"],["st","smalltalk"],["stylus","stylus"],["swift","swift"],["t","perl"],["tbc","tcl"],["tcl","tcl"],["tex","stex"],["toml","toml"],["ts","application/typescript"],["tsv","sql"],["tsx","text/typescript-jsx"],["ttl","text/turtle"],["twig","text/x-twig"],["txt","text"],["v","verilog"],["vb","vb"],["vhd","vhdl"],["vhdl","vhdl"],["vue","vue"],["wl","mathematica"],["wlua","lua"],["xml","xml"],["xq","xquery"],["xql","xquery"],["xqm","xquery"],["xquery","xquery"],["yaml","yaml"],["yml","yaml"]]);var g=class{file;extensions=F;constructor(e){this.file=e}async process(e,a=0,i=1e3){return new Promise((o,m)=>{if(a>i)return m(new Error("Nonsensical line numbers."));o(e.split($).filter((S,H)=>{let j=H+1;return j>=a&&j<=i}).join($))})}async rename(e,a){await se(e,a)}get getMimeType(){let e=ae(this.file,{preserveCase:!0});return this.extensions.has(e)?this.extensions.get(e):"auto"}};import ie from"tempy";import{homedir as oe}from"os";import{basename as re,extname as ne}from"path";import{nanoid as le}from"nanoid";var h=class{file;imgType;flags;tempDirectory=ie.directory();uniqueId=le(10);constructor(e){this.file=e}expandHomeDirectory(e){return e.startsWith("~")?e.replace("~",oe()):e}set setImgType(e){this.imgType=e}set setFlags(e){this.flags=e}get getSaveDirectory(){return this.flags.toClipboard?this.tempDirectory:this.expandHomeDirectory(this.flags.saveTo)}get getOriginalFileName(){return this.file?re(this.file,ne(this.file)):"stdin"}get getNewFileName(){return this.flags.saveAs||`${this.getOriginalFileName}-${this.uniqueId}`}get getDownloadedAsPath(){return`${this.getSaveDirectory}/carbon.${this.imgType}`}get getSavedAsPath(){return`${this.getSaveDirectory}/${this.getNewFileName}.${this.imgType}`}get getPath(){return this.flags.toClipboard?this.getDownloadedAsPath:this.getSavedAsPath}};import{chromium as _,firefox as pe,webkit as ce}from"@playwright/test";var N="https://carbon.now.sh/",u="carbon-now-cli-theme",R="CARBON_THEMES";var w=class{type;browser;page;pageOptions={viewport:{width:1800,height:1e3},deviceScaleFactor:2};static async create(e="chromium",a=!1,i="png"){if(!["png","svg"].includes(i))throw new Error("Invalid type. Only png and svg are supported.");let o=new this;return o.type=i,await o.init(e,a),o}getEngine(e){switch(e){case"chromium":return _;case"firefox":return pe;case"webkit":return ce;default:return _}}async init(e,a){this.browser=await this.getEngine(e).launch({headless:!a}),this.page=await this.browser.newPage(this.pageOptions)}async navigate(e){var a,i;await this.page.goto(e),await((a=await this.page.waitForSelector("#export-menu"))==null?void 0:a.click()),await((i=await this.page.$(`#export-${this.type}`))==null?void 0:i.click())}async setCustomTheme(e,a=u){await this.page.addInitScript(({highlights:i,theme:o,CARBON_LOCAL_STORAGE_KEY:m})=>{let S=[{id:o,name:o,highlights:i,custom:!0}];window.localStorage.setItem(m,JSON.stringify(S))},{highlights:e,theme:a,CARBON_LOCAL_STORAGE_KEY:R})}async download(e,a=process.cwd()){var i;try{let o=this.page.waitForEvent("download");await this.navigate(e),await((i=await o)==null?void 0:i.saveAs(`${a}/carbon.${this.type}`))}catch(o){throw new Error(o.message)}finally{await this.browser.close()}}};var me={t:"seti",bg:"#ADB7C1",wt:"none",wc:!0,fm:"Hack",fs:"18px",ln:!1,fl:1,ds:!1,dsyoff:"20px",dsblur:"68px",sl:"*",wa:!0,lh:"133%",pv:"48px",ph:"32px",si:!1,wm:!1,es:"2x",type:"png"},q=me;import de from"chalk";var D=t=>`
  ${de.red("Error: Sending code to https://carbon.now.sh went wrong.")}

  This is mostly due to:

  \xB7 Nonsensical input like \`--start 10 --end 2\`
  \xB7 Carbon being down or taking too long to respond
  \xB7 Your internet connection not working or being too slow

  Additional info:

  ${t}`;import fe from"chalk";import ge from"terminal-image";var B=async(t,e)=>{let a=`
  ${fe.green("Done!")}
	`;switch(!0){case t.openInBrowser:{a+=`
  Browser opened \u2014 finish your image there! \u{1F60C}`;break}case t.toClipboard:{a+=`
  Image copied to clipboard! \u{1F60C}`;break}default:a=`
  The file can be found here: ${e} \u{1F60C}
	`,process.env.TERM_PROGRAM&&process.env.TERM_PROGRAM.match("iTerm")&&(a+=`
  iTerm2 should display the image below. \u{1F60A}
  ${await ge.file(e)}`)}return a};var y=await d.create(),v=y.getFile,s=y.getFlags,ke=y.getInput,ve=y.getAnswers,L=new f(s.config),C=new g(v),p=new h(v),c=new xe([]),r={...q,l:C.getMimeType};s.preset&&(r={...r,...await L.getPreset(s.preset)});s.interactive&&(r={...r,...ve});s.config||await L.savePreset(r.preset,r);s.start&&(r={...r,fl:s.start});c.add([{title:`Processing ${v||(s.fromClipboard?"input from clipboard":"input from stdin")}`,task:async t=>{t.encodedContent=encodeURIComponent(await C.process(ke,s.start,s.end))}}]);c.add([{title:"Preparing connection",task:t=>{t.preparedURL=`${N}?${ye({...r,code:t.encodedContent,...r.custom&&{t:u}})}`,p.setFlags=s,p.setImgType=r.type}}]);c.add([{title:"Opening in browser",skip:!s.openInBrowser,task:({preparedURL:t})=>{he(t)}}]);c.add([{title:"Fetching beautiful image",skip:s.openInBrowser,task:async({preparedURL:t})=>{let e=await w.create(s.engine,s.disableHeadless,r.type);r.custom&&await e.setCustomTheme(r.custom,u),await e.download(t,p.getSaveDirectory),s.toClipboard||await C.rename(p.getDownloadedAsPath,p.getSavedAsPath)}}]);c.add([{title:"Copying image to clipboard",skip:!s.toClipboard||s.openInBrowser,task:async({preparedURL:t})=>{await be.writeImage(await x(p.getDownloadedAsPath,!1))}}]);try{await c.run(),console.log(await B(s,p.getPath)),ue({pkg:we.readFileSync("./package.json")}).notify(),process.exit()}catch(t){console.error(D(t.message)),process.exit(1)}
